diff --git a/examples/systemd/hive-daemon.service b/examples/systemd/hive-daemon.service
index 6b307132..6e2e1dab 100644
--- a/examples/systemd/hive-daemon.service
+++ b/examples/systemd/hive-daemon.service
@@ -71,6 +71,7 @@ Type=simple
 # system Ruby is assumed.
 Environment=HIVE_BIN=%h/.local/bin/hive
 Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+Environment=HIVE_XDG_ENVIRONMENT_PLACEHOLDER
 ExecStart=%h/.local/bin/hive daemon start
 Restart=on-failure
 RestartSec=30s
diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 00000000..ef006eee
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,19 @@
+# Hive local web UI. Managed by `hive web install`; run `hive web start` to
+# enable/load a unit previously written without service-manager side effects.
+[Unit]
+Description=Hive local web UI
+After=network-online.target
+Wants=network-online.target
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+Environment=HIVE_WEB_ENVIRONMENT_PLACEHOLDER
+ExecStart=%h/.local/bin/hive web
+Restart=on-failure
+RestartSec=10
+
+[Install]
+WantedBy=default.target
diff --git a/hive.gemspec b/hive.gemspec
index e54a3dec..178e4c6d 100644
--- a/hive.gemspec
+++ b/hive.gemspec
@@ -40,6 +40,13 @@ Gem::Specification.new do |spec|
     "schemas/**/*.json",
     "examples/systemd/*",
     "examples/launchd/*",
+    # The Rails source is immutable package payload. `hive setup` copies it
+    # beneath XDG data before Bundler/Rails write anything, so this does not
+    # make gem/Homebrew install locations mutable. Keep test/log/tmp outputs
+    # out of release artifacts.
+    *Dir.glob("web/**/*", File::FNM_DOTMATCH).select { |path|
+      File.file?(path) && path !~ %r{\Aweb/(?:test|tmp|log|storage|node_modules|\.git|script)/}
+    },
     "install.md",
     "CHANGELOG.md",
     "LICENSE",
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e..9c99ff70 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -25,7 +25,7 @@ module Hive
       "hive-forget" => 1,
       "hive-drop" => 2,
       "hive-prune" => 1,
-      "hive-daemon-status" => 1,
+      "hive-daemon-status" => 2,
       "hive-daemon-stop" => 1,
       "hive-daemon-enroll" => 1,
       "hive-daemon-reload" => 1,
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd809068..a620f81a 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -50,6 +50,31 @@ module Hive
     end
     map "--version" => :version
 
+    desc "setup [PROJECT_PATH]", "Provision Hive's local web control plane and enroll a project"
+    long_desc <<~DESC
+      Validates local readiness, provisions Hive-owned qmd and Rails runtime
+      dependencies, initializes or re-enrolls PROJECT_PATH (default: cwd),
+      enables its daemon participation, and starts separate daemon/web native
+      services. It prints http://127.0.0.1:4567 on success. Missing external
+      CLIs or credentials are reported with exact remediation after safe
+      Hive-owned provisioning has completed; setup then exits non-zero.
+    DESC
+    option :force, type: :boolean, default: false,
+                   desc: "repair recognized Hive-managed service units after timestamped backup"
+    option :unsafe_no_auth, type: :boolean, default: false,
+                             desc: "allow configured web.auth=none on a non-loopback bind (unsafe)"
+    def setup(project_path = nil)
+      if options[:json]
+        raise Hive::InvalidTaskPath, "hive setup has human-readable phase output; do not pass --json"
+      end
+
+      require "hive/commands/setup"
+      result = Hive::Commands::Setup.new(
+        project_path || Dir.pwd, force: options[:force], unsafe_no_auth: options[:unsafe_no_auth]
+      ).call
+      exit result.exit_code unless result.ready?
+    end
+
     desc "init [PROJECT_PATH]", "Bootstrap .hive-state (orphan hive/state branch); TTY-prompts for agents + limits"
     long_desc <<~DESC
       Initialises hive in PROJECT_PATH (defaults to the current directory):
@@ -1332,10 +1357,15 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
+    desc "web [ACTION]", "Run Hive's web UI or manage its local service"
     option :bind, type: :string, desc: "override web.bind"
     option :port, type: :numeric, desc: "override web.port"
-    def web
+    option :auth, type: :string, enum: %w[auto none github], desc: "override web.auth"
+    option :unsafe_no_auth, type: :boolean, default: false,
+                             desc: "allow auth=none on a non-loopback bind (unsafe)"
+    option :force, type: :boolean, default: false,
+                   desc: "for install: overwrite a differing managed unit after backing it up"
+    def web(action = nil)
       if options[:json]
         require "json"
         message = "hive web has no JSON output (it runs a long-lived server). " \
@@ -1355,7 +1385,17 @@ module Hive
       end
 
       require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      if options[:force] && action != "install"
+        raise Hive::InvalidTaskPath, "hive web #{action}: --force only applies to `install`"
+      end
+      if action && !%w[install start].include?(action)
+        raise Hive::InvalidTaskPath, "hive web: unknown action #{action.inspect} (expected: install or start)"
+      end
+
+      Hive::Commands::Web.new(
+        bind: options[:bind], port: options[:port], auth: options[:auth], unsafe_no_auth: options[:unsafe_no_auth],
+        action: action, force: options[:force]
+      ).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610b..87c90355 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -18,6 +18,7 @@ require "hive/daemon/answer_digest_scheduler"
 require "hive/daemon/logger"
 require "hive/daemon/dispatch_request_queue"
 require "hive/invoked_binary"
+require "hive/daemon/health"
 require "hive/update_check/state"
 
 module Hive
@@ -141,7 +142,13 @@ module Hive
         # Write the PID file as YAML with process_start_time so `stop`
         # can detect PID reuse before sending TERM/KILL to a random
         # process that happens to have the same PID. PR-40 review P2 #3.
-        File.write(pid_file, pid_file_payload(Process.pid, own_start_time).to_yaml)
+        File.write(
+          pid_file,
+          pid_file_payload(
+            Process.pid, own_start_time,
+            identity: { "invoked_binary" => current_binary_path, "hive_version" => Hive::VERSION }
+          ).to_yaml
+        )
 
         # Load the daemon block from ~/Dev/hive/config.yml so operator
         # overrides (max_concurrent_runs, poll_interval_sec, log paths,
@@ -358,6 +365,7 @@ module Hive
         running = false
         pid = nil
         uptime_sec = nil
+        payload = nil
 
         if File.exist?(pid_file)
           payload = read_pid_file_payload
@@ -369,8 +377,17 @@ module Hive
           end
         end
 
+        service_state = @json ? probe_service_state : nil
+        identity = Hive::Daemon::Health.new(
+          payload: payload,
+          current_binary: current_binary_path,
+          current_version: Hive::VERSION,
+          process_alive: ->(candidate) { pid_alive?(candidate) },
+          process_owned: ->(candidate_payload, candidate) { pid_owned_by_us?(candidate_payload, candidate) },
+          service_state: service_state
+        ).call
+
         if @json
-          service_state = probe_service_state
           puts JSON.generate(
             "schema" => "hive-daemon-status",
             "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
@@ -386,10 +403,17 @@ module Hive
             # Agent-native parity with the TUI footer / bot push: expose the
             # update nudge so a programmatic caller can detect "behind" too.
             "current_version" => Hive::VERSION,
+            "daemon_identity" => {
+              "state" => identity.state.to_s,
+              "mismatches" => identity.mismatches,
+              "invoked_binary" => payload && payload["invoked_binary"],
+              "hive_version" => payload && payload["hive_version"],
+              "remediation" => identity.remediation
+            },
             "update_nudge" => update_nudge_payload
           )
         elsif running
-          puts "hive daemon: running (pid #{pid}, uptime #{uptime_sec}s)"
+          puts "hive daemon: running (pid #{pid}, uptime #{uptime_sec}s) [identity #{identity.state}]"
         else
           puts "hive daemon: not running"
         end
diff --git a/lib/hive/commands/daemon/service_installer.rb b/lib/hive/commands/daemon/service_installer.rb
index 02cda2fb..f26a8be5 100644
--- a/lib/hive/commands/daemon/service_installer.rb
+++ b/lib/hive/commands/daemon/service_installer.rb
@@ -50,6 +50,7 @@ module Hive
             .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} daemon start")
             .sub(/^Environment=HIVE_BIN=.*$/, "Environment=HIVE_BIN=#{escaped}")
             .sub(/^Environment=PATH=.*$/, build_path_line)
+            .sub("Environment=HIVE_XDG_ENVIRONMENT_PLACEHOLDER", systemd_environment_lines.join("\n"))
         end
 
         def render_launchd
@@ -66,6 +67,7 @@ module Hive
             .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
             .gsub("/Users/YOU/Library/Logs", "#{escaped_home}/Library/Logs")
             .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+            .gsub("<!-- HIVE_XDG_ENVIRONMENT -->", launchd_environment_entries)
         end
       end
     end
diff --git a/lib/hive/commands/service_installer/base.rb b/lib/hive/commands/service_installer/base.rb
index 04f9ba76..fde9217d 100644
--- a/lib/hive/commands/service_installer/base.rb
+++ b/lib/hive/commands/service_installer/base.rb
@@ -81,6 +81,41 @@ module Hive
           }
         end
 
+        # Start a previously written unit without re-rendering or overwriting
+        # it. This keeps `install` (safe file mutation) distinct from `start`
+        # (service-manager mutation), and lets callers give an exact repair
+        # command when no unit exists yet.
+        def start!
+          unless target_path && File.file?(target_path)
+            raise Hive::Error, "#{service_noun} is not installed; run `hive #{cli_label} install` first"
+          end
+
+          case platform
+          when :linux
+            unless systemctl_available?
+              @messages << "systemd not detected; run `hive #{cli_label}` in the foreground"
+              return Outcome.new(:autostart_unavailable)
+            end
+            ok_reload = @runner.call(%w[systemctl --user daemon-reload])
+            ok_start = @runner.call([ "systemctl", "--user", "enable", "--now", service_name ])
+            unless ok_reload && ok_start
+              @messages << "systemctl --user enable failed; run `systemctl --user enable --now #{service_name}` manually"
+              return Outcome.new(:failed)
+            end
+            Outcome.new(:unchanged)
+          when :macos
+            ok = @runner.call([ "launchctl", "load", target_path ])
+            unless ok
+              @messages << "launchctl load failed for #{target_path}; run `launchctl load #{target_path}` manually"
+              return Outcome.new(:failed)
+            end
+            Outcome.new(:unchanged)
+          else
+            @messages << "#{cli_label} autostart not supported on this platform; run `hive #{cli_label}` manually."
+            Outcome.new(:unsupported)
+          end
+        end
+
         # launchd plist Label for this service. Matches the `<key>Label</key>`
         # value in the bundled plists (local.hive-daemon / local.hive-bot).
         def launchd_label
@@ -293,6 +328,39 @@ module Hive
           "Environment=PATH=#{base.join(':')}"
         end
 
+        # User services are launched outside the shell which invoked Hive.
+        # Bake the same non-secret Hive/XDG roots into generated units so the
+        # CLI, daemon, and local web app all read one registry and state tree.
+        # HIVE_HOME remains the legacy single-root override; otherwise retain
+        # the standard XDG split used by Hive::Paths.
+        def hive_service_environment
+          values = if ENV["HIVE_HOME"] && !ENV["HIVE_HOME"].empty?
+                     { "HIVE_HOME" => File.expand_path(ENV.fetch("HIVE_HOME")) }
+                   else
+                     {
+                       "XDG_CONFIG_HOME" => ENV.fetch("XDG_CONFIG_HOME", File.join(@home, ".config")),
+                       "XDG_DATA_HOME" => ENV.fetch("XDG_DATA_HOME", File.join(@home, ".local/share")),
+                       "XDG_STATE_HOME" => ENV.fetch("XDG_STATE_HOME", File.join(@home, ".local/state")),
+                       "XDG_CACHE_HOME" => ENV.fetch("XDG_CACHE_HOME", File.join(@home, ".cache"))
+                     }
+                   end
+          values["XDG_BIN_HOME"] = ENV["XDG_BIN_HOME"] if ENV["XDG_BIN_HOME"] && !ENV["XDG_BIN_HOME"].empty?
+          values
+        end
+
+        def systemd_environment_lines(values = hive_service_environment)
+          values.map do |key, value|
+            escaped = value.to_s.gsub("\\", "\\\\").gsub('"', '\\"')
+            "Environment=\"#{key}=#{escaped}\""
+          end
+        end
+
+        def launchd_environment_entries(values = hive_service_environment)
+          values.map do |key, value|
+            "<key>#{CGI.escapeHTML(key)}</key>\n    <string>#{CGI.escapeHTML(value.to_s)}</string>"
+          end.join("\n    ")
+        end
+
         def ruby_shim_dir
           ruby_path = which("ruby")
           return nil unless ruby_path
diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 00000000..681fa198
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,265 @@
+require "json"
+require "net/http"
+require "pathname"
+require "socket"
+require "time"
+
+require "hive"
+require "hive/config"
+require "hive/invoked_binary"
+require "hive/commands/init"
+require "hive/commands/daemon"
+require "hive/commands/setup/backend_prompt"
+require "hive/commands/setup/preflight"
+require "hive/commands/setup/qmd_installer"
+require "hive/commands/setup/web_provisioner"
+require "hive/commands/daemon/service_installer"
+require "hive/commands/web"
+require "hive/commands/web/service_installer"
+require "hive/web/auth_policy"
+require "hive/web/runtime_layout"
+
+module Hive
+  module Commands
+    # Idempotent local-control-plane orchestration. Every phase records an
+    # independently rerunnable result; external dependency gaps never prevent
+    # the qmd/runtime/service work Hive itself owns from being attempted.
+    class Setup
+      Phase = Data.define(:name, :status, :message) do
+        READY_STATES = %i[ready fixed].freeze
+
+        def ready?
+          READY_STATES.include?(status)
+        end
+      end
+      Result = Data.define(:project_path, :url, :phases) do
+        def exit_code
+          phases.all?(&:ready?) ? 0 : 1
+        end
+
+        def ready?
+          exit_code.zero?
+        end
+      end
+
+      def initialize(project_path = Dir.pwd, force: false, unsafe_no_auth: false, output: $stdout,
+                     preflight: nil, qmd_installer: nil, web_provisioner: nil,
+                     backend_prompt: nil, project_enroller: nil,
+                     daemon_installer: nil, web_installer: nil,
+                     foreground_web: nil,
+                     endpoint_probe: nil, deep_health_probe: nil,
+                     sleeper: ->(seconds) { sleep(seconds) }, health_timeout: 20)
+        @project_path = File.realpath(project_path)
+        raise Hive::InvalidTaskPath, "hive setup: project path is not a directory: #{project_path}" unless File.directory?(@project_path)
+        @force = force
+        @unsafe_no_auth = unsafe_no_auth
+        @output = output
+        @preflight = preflight || Setup::Preflight.new
+        @qmd_installer = qmd_installer || Setup::QmdInstaller.new
+        @web_provisioner = web_provisioner || Setup::WebProvisioner.new
+        @backend_prompt = backend_prompt || Setup::BackendPrompt.new
+        @project_enroller = project_enroller || method(:enroll_project!)
+        @daemon_installer = daemon_installer
+        @web_installer = web_installer
+        @foreground_web = foreground_web || -> { Hive::Commands::Web.new(unsafe_no_auth: @unsafe_no_auth).call }
+        @endpoint_probe = endpoint_probe || method(:probe_endpoint)
+        @deep_health_probe = deep_health_probe || method(:deep_health?)
+        @sleeper = sleeper
+        @health_timeout = health_timeout
+        @phases = []
+      rescue Errno::ENOENT
+        raise Hive::InvalidTaskPath, "hive setup: project path does not exist: #{project_path}"
+      end
+
+      def call
+        run_preflight
+        configure_backends
+        provision_qmd
+        provision_web_runtime
+        enroll
+        install_daemon
+        configure_web
+        return print_and_launch_foreground_web if @foreground_web_fallback
+
+        wait_for_deep_health
+        result = Result.new(@project_path, url, @phases.freeze)
+        print_summary(result)
+        result
+      end
+
+      private
+
+      def run_preflight
+        @preflight.call(rails_ready: false).each do |row|
+          @phases << Phase.new(row.name, row.ready? ? :ready : :needs_attention,
+                               row.ready? ? "ready" : row.remediation)
+        end
+      rescue StandardError => e
+        @phases << Phase.new("preflight", :failed, e.message)
+      end
+
+      def configure_backends
+        selected = @backend_prompt.collect
+        Hive::Config.write_global_agents!(selected)
+        @phases << Phase.new("agent backends", :fixed, selected.join(", "))
+      rescue StandardError => e
+        @phases << Phase.new("agent backends", :needs_attention, e.message)
+      end
+
+      def provision_qmd
+        outcome = @qmd_installer.call
+        status = outcome.status == :installed ? :fixed : :needs_attention
+        replace_phase("qmd", status, (outcome.message if outcome.respond_to?(:message)) || outcome.status.to_s)
+      rescue StandardError => e
+        replace_phase("qmd", :needs_attention, e.message)
+      end
+
+      def provision_web_runtime
+        outcome = @web_provisioner.call
+        status = outcome.status == :provisioned ? :fixed : :ready
+        replace_phase("web runtime", status, (outcome.message if outcome.respond_to?(:message)) || outcome.status.to_s)
+      rescue StandardError => e
+        replace_phase("web runtime", :needs_attention, e.message)
+      end
+
+      def enroll
+        state = @project_enroller.call(@project_path)
+        @phases << Phase.new("project enrollment", state == :ready ? :ready : :fixed, @project_path)
+      rescue StandardError => e
+        @phases << Phase.new("project enrollment", :failed, e.message)
+      end
+
+      def install_daemon
+        installer = @daemon_installer || Hive::Commands::Daemon::ServiceInstaller.new(binary_path: Hive::InvokedBinary.path)
+        outcome = installer.install!(autostart: true, force: @force)
+        if outcome.drifted?
+          @phases << Phase.new("daemon service", :needs_attention,
+                               "custom daemon unit detected; run `hive setup --force` to back it up and repair it")
+        elsif outcome.failed?
+          @phases << Phase.new("daemon service", :failed, "daemon service manager failed")
+        elsif outcome.kind == :autostart_unavailable
+          # The explicit Linux fallback remains a real daemon, but no claim of
+          # reboot persistence is made in the final summary.
+          Hive::Commands::Daemon.new("start", detach: true).call
+          @phases << Phase.new("daemon service", :fixed, "systemd-user unavailable; started detached daemon")
+        else
+          @phases << Phase.new("daemon service", outcome.kind == :unchanged ? :ready : :fixed, outcome.kind.to_s)
+        end
+      rescue StandardError => e
+        @phases << Phase.new("daemon service", :failed, e.message)
+      end
+
+      def configure_web
+        case @endpoint_probe.call
+        when :healthy_hive
+          @phases << Phase.new("web endpoint", :ready, "existing healthy Hive server at #{url}")
+          return
+        when :occupied
+          @phases << Phase.new("web endpoint", :failed,
+                               "#{url} is occupied by another listener; set web.port or rerun with `hive web --port PORT`")
+          return
+        end
+
+        cfg = Hive::Config.load_global_web
+        policy = Hive::Web::AuthPolicy.new(
+          bind: cfg.fetch("bind"), configured_mode: cfg.fetch("auth"), unsafe_no_auth: @unsafe_no_auth
+        )
+        unless policy.allowed?
+          @phases << Phase.new("web service", :failed, policy.refusal_message)
+          return
+        end
+        installer = @web_installer || Hive::Commands::Web::ServiceInstaller.new(
+          config: cfg, binary_path: Hive::InvokedBinary.path, unsafe_no_auth: @unsafe_no_auth
+        )
+        written = installer.install!(autostart: false, force: @force)
+        if written.drifted?
+          @phases << Phase.new("web service", :needs_attention,
+                               "custom web unit detected; run `hive web install --force` to repair it")
+          return
+        end
+        started = installer.start!
+        if started.failed?
+          @phases << Phase.new("web service", :failed, "web service manager failed")
+        elsif started.kind == :autostart_unavailable
+          # The web command execs the foreground Rails server after the setup
+          # summary. This gives Linux hosts without systemd-user a usable
+          # one-command local launch while stating that it is not persistent.
+          @foreground_web_fallback = true
+          @phases << Phase.new("web service", :fixed,
+                               "systemd-user is unavailable; launching foreground web at #{url} (not reboot-persistent)")
+        else
+          @phases << Phase.new("web service", :fixed, "started #{installer.service_name}")
+        end
+      rescue StandardError => e
+        @phases << Phase.new("web service", :failed, e.message)
+      end
+
+      def wait_for_deep_health
+        return if @phases.any? { |phase| [ "daemon service", "web service", "web endpoint" ].include?(phase.name) && phase.status == :failed }
+
+        deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + @health_timeout
+        until Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+          if @deep_health_probe.call
+            @phases << Phase.new("deep health", :ready, "#{url}/health?deep=1")
+            return
+          end
+          @sleeper.call(0.2)
+        end
+        @phases << Phase.new("deep health", :failed, "timed out waiting for #{url}/health?deep=1")
+      rescue StandardError => e
+        @phases << Phase.new("deep health", :failed, e.message)
+      end
+
+      def enroll_project!(path)
+        state_config = File.join(path, ".hive-state", "config.yml")
+        if File.file?(state_config)
+          Hive::Config.register_project(name: File.basename(path), path: path)
+        else
+          # force bypasses only the clean-tree prompt, not git validation or
+          # initial state creation. Noninteractive invocations receive Init's
+          # normal defaults.
+          Hive::Commands::Init.new(path, force: true).call
+        end
+        Hive::Commands::Daemon.new("enable", File.basename(path)).call
+        :ready
+      end
+
+      def probe_endpoint
+        uri = URI("#{url}/health?deep=1")
+        response = Net::HTTP.start(uri.host, uri.port, open_timeout: 1, read_timeout: 1) { |http| http.get(uri) }
+        body = JSON.parse(response.body) rescue {}
+        response.is_a?(Net::HTTPSuccess) && body["ok"] == true ? :healthy_hive : :occupied
+      rescue Errno::ECONNREFUSED, Errno::EHOSTUNREACH, SocketError, Net::OpenTimeout, Net::ReadTimeout
+        :free
+      end
+
+      def deep_health?
+        @endpoint_probe.call == :healthy_hive
+      end
+
+      def replace_phase(name, status, message)
+        index = @phases.index { |phase| phase.name == name }
+        phase = Phase.new(name, status, message)
+        index ? @phases[index] = phase : @phases << phase
+      end
+
+      def url
+        cfg = Hive::Config.load_global_web
+        "http://#{cfg.fetch('bind')}:#{cfg.fetch('port')}"
+      end
+
+      def print_summary(result)
+        result.phases.each { |phase| @output.puts "#{phase.status}: #{phase.name} — #{phase.message}" }
+        @output.puts "Hive local web: #{result.url}"
+        @output.puts(result.ready? ? "hive setup: ready" : "hive setup: needs attention; see remediation above")
+      end
+
+      def print_and_launch_foreground_web
+        result = Result.new(@project_path, url, @phases.freeze)
+        print_summary(result)
+        @foreground_web.call
+        result
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/setup/preflight.rb b/lib/hive/commands/setup/preflight.rb
new file mode 100644
index 00000000..059bfd0c
--- /dev/null
+++ b/lib/hive/commands/setup/preflight.rb
@@ -0,0 +1,137 @@
+require "open3"
+require "rbconfig"
+require "timeout"
+
+require "hive"
+require "hive/paths"
+
+module Hive
+  module Commands
+    class Setup
+      # Read-only readiness report used by setup and doctor.  Keeping the
+      # result structured makes it possible to continue safe Hive-owned work
+      # while still returning a truthful non-zero setup result later.
+      class Preflight
+        Result = Data.define(:name, :path, :version, :status, :severity, :hive_owned, :remediation, :message) do
+          def ready?
+            status == :ready
+          end
+        end
+
+        EXTERNAL_TOOLS = {
+          "git" => "install git with your OS package manager",
+          "tmux" => "install tmux with your OS package manager",
+          "gh" => "install gh, then run `gh auth login`",
+          "claude" => "install Claude Code, then run `claude login`",
+          "codex" => "install Codex, then run `codex login`",
+          "node" => "install Node.js 20+ with your OS package manager or nvm",
+          "npm" => "install npm with Node.js"
+        }.freeze
+
+        def initialize(which: nil, runner: nil, ruby_version: RUBY_VERSION, sqlite_check: nil, timeout: 10)
+          @which = which || method(:which)
+          @runner = runner || method(:run)
+          @ruby_version = ruby_version
+          @sqlite_check = sqlite_check || method(:sqlite_available?)
+          @timeout = timeout
+        end
+
+        def call(rails_ready:)
+          [ ruby_result, *EXTERNAL_TOOLS.map { |name, remediation| tool_result(name, remediation) },
+            qmd_result, sqlite_result, web_runtime_result(rails_ready) ]
+        end
+
+        private
+
+        def ruby_result
+          current = Gem::Version.new(@ruby_version.to_s)
+          if current >= Gem::Version.new("3.4.0")
+            result("ruby", path: RbConfig.ruby, version: @ruby_version, status: :ready,
+                   hive_owned: false, remediation: "install Ruby 3.4+ with mise, rbenv, asdf, or your OS package manager")
+          else
+            result("ruby", path: RbConfig.ruby, version: @ruby_version, status: :needs_attention,
+                   hive_owned: false, remediation: "install Ruby 3.4+ with mise, rbenv, asdf, or your OS package manager")
+          end
+        end
+
+        def tool_result(name, remediation)
+          path = @which.call(name)
+          return result(name, status: :needs_attention, hive_owned: false, remediation: remediation) unless path
+
+          probe = @runner.call([ path, "--version" ], timeout: @timeout)
+          if probe.fetch(:ok, false)
+            result(name, path: path, version: probe[:stdout].to_s.lines.first.to_s.strip, status: :ready,
+                   hive_owned: false, remediation: remediation)
+          else
+            result(name, path: path, status: :needs_attention, hive_owned: false, remediation: remediation,
+                   message: probe[:stderr].to_s.strip)
+          end
+        rescue Timeout::Error
+          result(name, path: path, status: :needs_attention, hive_owned: false, remediation: remediation,
+                 message: "version probe timed out")
+        end
+
+        def qmd_result
+          path = @which.call("qmd") || managed_qmd_path
+          if path && File.file?(path) && File.executable?(path)
+            probe = @runner.call([ path, "--version" ], timeout: @timeout)
+            return result("qmd", path: path, version: probe[:stdout].to_s.strip, status: :ready,
+                          hive_owned: true, remediation: "run `hive setup` to repair Hive's qmd install") if probe.fetch(:ok, false)
+          end
+
+          result("qmd", path: path, status: :needs_attention, hive_owned: true,
+                 remediation: "run `hive setup` to install or repair Hive's qmd indexer")
+        rescue Timeout::Error
+          result("qmd", path: path, status: :needs_attention, hive_owned: true,
+                 remediation: "run `hive setup` to repair Hive's qmd indexer", message: "version probe timed out")
+        end
+
+        def sqlite_result
+          if @sqlite_check.call
+            result("sqlite", status: :ready, hive_owned: false,
+                   remediation: "reinstall Hive's sqlite3 Ruby dependency for this Ruby")
+          else
+            result("sqlite", status: :needs_attention, hive_owned: false,
+                   remediation: "reinstall Hive's sqlite3 Ruby dependency for this Ruby")
+          end
+        end
+
+        def web_runtime_result(ready)
+          result("web runtime", status: ready ? :ready : :needs_attention, hive_owned: true,
+                 remediation: "run `hive setup` to provision the local Rails runtime")
+        end
+
+        def result(name, path: nil, version: nil, status:, hive_owned:, remediation:, message: nil)
+          Result.new(name, path, version, status, status == :ready ? :info : :error, hive_owned, remediation, message)
+        end
+
+        def managed_qmd_path
+          File.join(Hive::Paths.data_home, "qmd", "bin", "qmd")
+        end
+
+        def which(name)
+          ENV.fetch("PATH", "").split(File::PATH_SEPARATOR).each do |dir|
+            candidate = File.join(dir, name)
+            return candidate if File.file?(candidate) && File.executable?(candidate)
+          end
+          nil
+        end
+
+        def run(argv, timeout:)
+          stdout, stderr, status = Timeout.timeout(timeout) { Open3.capture3(*argv) }
+          { ok: status.success?, stdout: stdout, stderr: stderr }
+        end
+
+        def sqlite_available?
+          require "sqlite3"
+          database = SQLite3::Database.new(":memory:")
+          database.get_first_value("select 1") == 1
+        rescue LoadError, SQLite3::Exception
+          false
+        ensure
+          database&.close
+        end
+      end
+    end
+  end
+end
